//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

// $Header: fsdelete.c,r42 2006-02-18 04:23:47 ingo $


#include "fsyspriv.h"






int FSDelete(char *name)
{
FS_FILE *entry;
int error;
FS_VOLUME *fs;

error=FSInit();
if(error!=FS_OK) return error;


entry=(FS_FILE *)malloc(sizeof(FS_FILE));
if(entry==NULL) return FS_ERROR;

// CLEAN ENTRY
memset((void *)entry,0,sizeof(FS_FILE));


// CHECK IF CARD IS PRESENT

error=FSVolumePresent(FSystem.Volumes[FSystem.CurrentVolume]);
if(error!=FS_OK) { free(entry); return error; }


error=FSFindFile(name,entry,FALSE);

if(error!=FS_OK) { 
free(entry); return error;
}

fs=FSystem.Volumes[entry->Volume];


error=FSDeleteDirEntry(entry);			// MARK ENTRY AS DELETED
if(error!=FS_OK) {
while(entry) entry=FSFreeFile(entry);
return error;
}

error=FSGetChain(entry->FirstCluster,&entry->Chain,fs);
if(error!=FS_OK) {
while(entry) entry=FSFreeFile(entry);
return error;
}

error=FSTruncateChain(entry,0);		// FREE CLUSTER CHAIN
while(entry) entry=FSFreeFile(entry);

if(error!=FS_OK) {
return error;
}

return FSFlushFATCache(fs);

}


