//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

#include <hpgcc3.h>
extern "C" {
#include <ggl.h>
}

#include "memblock.h"
#include "gstring.h"
#include "gui.h"
#include "resources.h"





gStaticText::gStaticText(gControl& _Parent,int x,int y,const char *_Text,gFont *f,int color)
: gControl(_Parent)
{
	posx=x;
	posy=y;
	Color=color;
	
	memcpy(&Font,f,sizeof(gFont));

	Text=new char[strlen(_Text)+1];

	if(!Text) return;

	strcpy(Text,_Text);

	sizey=Font.TextHeight();
	sizex=Font.TextWidth(Text);

}

gStaticText::~gStaticText()
{
if(Text) { delete Text; Text=NULL; }	
}

void gStaticText::Update(gUpdate *u)
{
Parent->DrawText(posx,posy,Text,&Font,Color);
}

void gStaticText::SetText(const char *_Text)
{
if(Text) { delete Text; Text=NULL; }

Text=new char[strlen(_Text)+1];

// CLEAN OLD TEXT
gUpdate u;
u.clipx=posx;
u.clipy=posy;
u.clipx2=posx+sizex-1;
u.clipy2=posy+sizey-1;

Parent->ClearClipRegion();
Parent->RedrawBackground(&u);

if(!Text) return;

strcpy(Text,_Text);

sizex=Font.TextWidth(Text);

u.clipx2=posx+sizex-1;

Parent->DrawText(posx,posy,Text,&Font,Color);
}

const char *gStaticText::GetText()
{
	return (const char*)Text;
}
