//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file as well as the entire HPG library was written by Chris Smith
//& for HPGCC 1.0, now maintained by the HPGCC3 team.
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



#include <stddef.h>
#include "hpgraphics.h"
#include "hpgpriv.h"

/*
 * Common drawing function.  This function provides clipping and culling
 * of draws to avoid duplication between the drawing modes.  It then
 * delegates to mode-specific code for the actual drawing.
 */
void _hpg_draw(hpg_t *g, int x, int y, int len, int patx, int paty)
{
    /*
     * Clip to clipping region.  Any drawing that lies entirely off the
     * screen, in either the x or y dimensions, is culled here.
     */
    if ((y < g->clipy1) || (y >= g->clipy2)) return;
    if (x < g->clipx1)
    {
        len += x - g->clipx1;
        x = g->clipx1;
    }
    if (x + len >= g->clipx2)
    {
        len = g->clipx2 - x;
    }

    if (len <= 0) return;

    /*
     * Delegate to mode-specific code for the remainder of the drawing.
     */
    (*g->drawfn)(g, x, y, len, patx, paty);
}
