//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file as well as the entire HPG library was written by Chris Smith
//& for HPGCC 1.0, now maintained by the HPGCC3 team.
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



#include <stdlib.h>
#include "hpgraphics.h"
#include "hpgpriv.h"
#include <master_globals.h>

void hpg_set_indicator(unsigned char indicator, unsigned char color)
{
    hpg_init();

    /*
     * A special graphics device to be used for turning the screen indicators
     * on or off.  This device is identical to the main graphics device except
     * for the modified clipping rectangle, which allows writing to the
     * off-screen segments corresponding to the indicators.
     *
     * The locations of the indicator pixels are:
     *
     * (131, 0) - Remote
     * (131, 1) - Left Shift
     * (131, 2) - Right Shift
     * (131, 3) - Alpha
     * (131, 4) - Low Battery
     * (131, 5) - Wait
     */
    static hpg_t indicator_hpg;
    indicator_hpg = *__mg->hpg_stdscreen;
    indicator_hpg.clipx1 = 0;
    indicator_hpg.clipx2 = 160;
    indicator_hpg.clipy1 = 0;
    indicator_hpg.clipy2 = 80;

    indicator_hpg.color = color;
    hpg_draw_pixel_on(&indicator_hpg, 131, indicator);
}
