//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file as well as the entire HPG library was written by Chris Smith
//& for HPGCC 1.0, now maintained by the HPGCC3 team.
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



#ifndef __MASTER_GLOBALS_H
#include <master_globals.h>
#endif

#define DEFAULT_PLANE ((char *) __mg->__console_vars->__display_buf)

#define SCR_WIDTH 131
#define SCR_HEIGHT 80

#ifndef min
#define min(a, b) (((a) < (b)) ? (a) : (b))
#endif /* min */
#ifndef max
#define max(a, b) (((a) > (b)) ? (a) : (b))
#endif /* max */

struct hpg_graphics
{
    char *org_fb1,*org_fb2;
    volatile char *fb;
    volatile char *drawfb;
    void (*drawfn)(hpg_t *g, int x, int y, int len, int patx, int paty);
    unsigned char (*getfn)(hpg_t *g, int x, int y);
    unsigned int width, height;
    unsigned int fbwidth;
    unsigned int clipx1, clipy1, clipx2, clipy2;
    unsigned char mode;
    unsigned char color;
    hpg_pattern_t *pattern;
    hpg_font_t *font;
};

struct hpg_font
{
    char *buffer;
    unsigned int count;
    unsigned char height;
    unsigned char advance;
};

struct hpg_pattern
{
    char *buffer;
    unsigned char height;
    unsigned char fixed;
};

void _hpg_set_mode(int mode,char *visfb, char *drawfb,
    void (*drawfn)(hpg_t *, int, int, int, int, int),
    unsigned char (*getfn)(hpg_t *, int, int));

void _hpg_mono_draw(hpg_t *g, int x, int y, int len, int patx, int paty);
void _hpg_gray4_draw(hpg_t *g, int x, int y, int len, int patx, int paty);
void _hpg_gray16_draw(hpg_t *g, int x, int y, int len, int patx, int paty);
unsigned char _hpg_mono_get(hpg_t *g, int x, int y);
unsigned char _hpg_gray4_get(hpg_t *g, int x, int y);
unsigned char _hpg_gray16_get(hpg_t *g, int x, int y);
void _hpg_draw(hpg_t *g, int x, int y, int len, int patx, int paty);
void _hpg_poly(hpg_t *g, int vx[], int vy[], int len, int fill);

struct hpg_xpm_info
{
    int width, height;
    int ncolors;
    int cpp;
};

struct hpg_xpm_info _hpg_get_xpm_info(char *xpm[]);
void _hpg_load_xpm(struct hpg_xpm_info info, hpg_t *img, char *xpm[]);



