//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


// $Id: dtoa.c 514 2007-11-18 03:11:26Z ingo $

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>


#define MAXDIGITS 15
#define TINY_EXP 1.0e-15
#define BIG_EXP 1.0e15

#define DEFAULT_EXPO_SYM 'E'
#define NORMALIZED_MANTISSA 0


// OBSOLETE - CLAUDIO - MAR 2006
// TODO: REMOVE OR REPLACE BY CALLS TO xr_xrtoa()

            
char *
__dtoa(double x, char *buf, char expo_sym)
{
    int digits,max_digits;
    int minus,expo,write_expo;
    char fraction[MAXDIGITS+1];
    char integral[MAXDIGITS+1];
    char exps[8];
    
    digits = minus = expo = write_expo = 0;
    max_digits = min(get_decimal_digits(),MAXDIGITS);
    memset(fraction,'0',max_digits);
    fraction[max_digits] = '\0';
    strcpy(integral,"0");
    
    
    if (x != 0.0) {
        
        int expo2;
        
        if ((minus = x < 0.0))
            x = -x;
        
        frexp(x,&expo2);
        expo = (int) (expo2*M_LN2/M_LN10);
        
        write_expo = ( expo_sym == 'e' || expo_sym == 'E' || (expo_sym == 'g' && ( x >= BIG_EXP || x <= TINY_EXP  || ((abs(expo)) > max_digits))) );
        
        if (write_expo) 
            // scale for exponential representation 
			
			// REPLACED WITH MORE ACCURATE I10POWX BY CLAUDIO - MAR 2006
            //x *= ipow(10.0,-expo);
			x *= i10powx(-expo);
        

        double ip;
        
        modf(x,&ip); 
        LONGLONG lip = (LONGLONG) ip;
        lltoa(lip,integral,10);
        
        LONGLONG nlp=1,lpow;
    
        int k;
        for(k = 0; k < max_digits-1; k++)
            nlp *= 10;
        lpow = 10 * nlp;
        
        LONGLONG lfrac;
        
        lfrac = (LONGLONG) dround(x * lpow,0) - lip * lpow;
        
        if (lfrac != 0LL) {
            
#if NORMALIZED_MANTISSA

            // Force a normalized exponential representation;
            // x.ddd Eeee , where x > 0
            
            // This is expensive in terms of space.
            // It adds an 2+ K overhead for the LONGLONG division
            
            if (write_expo && lip == 0LL) {
                LONGLONG nip;
                
                nip = lfrac / nlp;
                lfrac = 10*(lfrac - nip*nlp);
                lltoa(nip,integral,10);
                expo--;
                
            }
#endif
            char fmt[8];
            
            sprintf(fmt,"%%0%dL",max_digits);
            sprintf(fraction,fmt,lfrac);
        }
        
    }
    
    sprintf(buf,"%s%s%s%s",minus ? "-" : "",integral,max_digits ? get_decimal_separator() : "",fraction);
    
    if (write_expo) {
        int m;
        if ((m = expo < 0))
            expo = -expo;
        if (! (expo_sym == 'e' || expo_sym == 'E'))
            expo_sym = DEFAULT_EXPO_SYM;
        sprintf(exps,"%c%c%03d",expo_sym,m ? '-' : '+', expo);
        strcat(buf,exps);
    }
    
    return buf; 
    
}
