//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: bsearch.c 514 2007-11-18 03:11:26Z ingo $

#include <stdlib.h>


void *
bsearch(register const void *key, register const void *base,
    register size_t n_elements, register size_t size,
    int (*compar)(const void *, const void *))
{
    register const void *mid;
    register int  cmp;

    while (n_elements > 0) {
        mid = (char *)base + size * (n_elements >> 1);
        if ((cmp = (*compar)(key, mid)) == 0)
            return (void *)mid;
        if (cmp >= 0) {
            base  = (char *)mid + size;
            n_elements = (n_elements - 1) >> 1;
        } else
            n_elements >>= 1;
    }
    return (void *) NULL;
}
