//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: launch_rcl_romp.c 393 2007-03-04 23:17:29Z ingo $

#include <hpgcc3.h>
#include "launcher.h"

// GIVEN SWITCH ADDR, RETURN SATURN BANK NUMBER
// -3=ERROR, -1=MAIN RAM, -2=ERAM, 0-15=FLASH BANK
int __launch_getbanknum(int switchaddr,SAT_CPU *cpu)
{
int table=0x26BBB,f;

if(!switchaddr) return -1;		// MAIN RAM

// SCAN FOR FLASH BANKS
for(f=0;f<16;++f,table+=7) 
{
if(__launch_peek(table,5,cpu)==switchaddr) return f;
}

// NOT A FLASH BANK, MUST BE ERAM
table=0x26c39;
if(__launch_peek(table,5,cpu)==switchaddr) return -2;		// ERAM

return -3;	// ERROR

}






// FIND ROMP FOR EXECUTION, RETURN 0 IF NOT FOUND

int launch_rcl_romp(int rompaddr,SAT_CPU *cpu)
{
int libnum,ptrnum,rompart,items,libaddr;

libnum=__launch_peek(rompaddr+5,3,cpu);
ptrnum=__launch_peek(rompaddr+8,3,cpu);

rompart=0x8611d;
items=__launch_peek(rompart,3,cpu);
rompart+=3;
while(items--) {
if(__launch_peek(rompart,3,cpu)==libnum) {
// FOUND LIBRARY
rompart+=3;
libaddr=__launch_peek(rompart,5,cpu);	// GET LIBRARY ADDRESS
rompart+=5;
items=__launch_getbanknum(__launch_peek(rompart,5,cpu),cpu);	// GET BANK NUMBER
rompaddr=((items&0xff)<<20) + libaddr;

// FIND ADDRESS OF ROMPOINTER WITHIN LIBRARY
if(__launch_peek(rompaddr,3,cpu)!=libnum) return 0;		// LIBRARY IS INVALID

rompaddr+=13;

rompaddr+=__launch_peek(rompaddr,5,cpu)+5;		// FIND LINK TABLE WITHIN LIB

if((ptrnum+1)*5 >= __launch_peek(rompaddr,5,cpu) ) return 0;		// INEXISTENT ROMPTR

rompaddr+=(ptrnum+1)*5;
return rompaddr+__launch_peek(rompaddr,5,cpu);		// RETURN POINTER TO PROLOG OF ROMPOINTER

}



rompart+=16;
}

return 0;
}

